Index: issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py	(revision 12878)
@@ -1,44 +1,47 @@
-from numpy import *
+import os
+import numpy
+
 def SetIceShelfBC(md,icefrontfile=''):
-	#SETICESHELFBC - Create the boundary conditions for diagnostic and thermal models for a  Ice Shelf with Ice Front
-	#
-	#   Neumann BC are used on the ice front (an ANRGUS contour around the ice front
-	#   must be given in input)
-	#   Dirichlet BC are used elsewhere for diagnostic
-	#
-	#   Usage:
-	#      md=SetIceShelfBC(md,varargin)
-	#
-	#   Example:
-	#      md=SetIceShelfBC(md);
-	#      md=SetIceShelfBC(md,'Front.exp');
-	#
-	#   See also: SETICESHEETBC, SETMARINEICESHEETBC
+	"""
+	SETICESHELFBC - Create the boundary conditions for diagnostic and thermal models for a  Ice Shelf with Ice Front
+	 
+	    Neumann BC are used on the ice front (an ANRGUS contour around the ice front
+	    must be given in input)
+	    Dirichlet BC are used elsewhere for diagnostic
+	 
+	    Usage:
+	       md=SetIceShelfBC(md,varargin)
+	 
+	    Example:
+	       md=SetIceShelfBC(md);
+	       md=SetIceShelfBC(md,'Front.exp');
+	 
+	    See also: SETICESHEETBC, SETMARINEICESHEETBC
+	"""
 
 	#node on Dirichlet (boundary and ~icefront)
-	if not icefrontfile:
-		nodeonicefront=zeros(md.mesh.numberofvertices)
+	if icefrontfile:
+		if not os.path.exists(icefrontfile):
+			raise IOError("SetIceShelfBC error message: ice front file '%s' not found." % icefrontfile)
+		nodeinsideicefront=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,icefrontfile,'node',2)
+		nodeonicefront=double(md.mesh.vertexonboundary and nodeinsideicefront)
 	else:
-		if not os.path.isfile(icefrontfile):
-			print 'SetIceShelfBC error message: ice front file '+icefrontfile+ ' not found'
-			return []
-		nodeinsideicefront=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,icefrontfile,'node',2)
-		nodeonicefront=double(md.mesh.vertexonboundary.astype(bool) and nodeinsideicefront.astype(bool))
-	
-	pos=argwhere(logical_and(md.mesh.vertexonboundary.astype(bool),~nodeonicefront.astype(bool)))
-	md.diagnostic.spcvx=NaN*ones(md.mesh.numberofvertices);
-	md.diagnostic.spcvy=NaN*ones(md.mesh.numberofvertices);
-	md.diagnostic.spcvz=NaN*ones(md.mesh.numberofvertices);
-	md.diagnostic.spcvx[pos]=0;
-	md.diagnostic.spcvy[pos]=0;
-	md.diagnostic.spcvz[pos]=0;
-	md.diagnostic.referential=float('NaN')*ones((md.mesh.numberofvertices,6),float);
+		nodeonicefront=numpy.zeros(md.mesh.numberofvertices)
+
+#	pos=find(md.mesh.vertexonboundary & ~nodeonicefront);
+	pos=[i for i,(vob,noif) in enumerate(zip(md.mesh.vertexonboundary,nodeonicefront)) if vob and not noif]
+	md.diagnostic.spcvx=float('NaN')*numpy.ones(md.mesh.numberofvertices)
+	md.diagnostic.spcvy=float('NaN')*numpy.ones(md.mesh.numberofvertices)
+	md.diagnostic.spcvz=float('NaN')*numpy.ones(md.mesh.numberofvertices)
+	md.diagnostic.spcvx[pos]=0
+	md.diagnostic.spcvy[pos]=0
+	md.diagnostic.spcvz[pos]=0
+	md.diagnostic.referential=float('NaN')*numpy.ones((md.mesh.numberofvertices,6))
 
 	#Dirichlet Values
-	if ~isnan(md.inversion.vx_obs) and ~isnan(md.inversion.vy_obs):
-		if (len(md.inversion.vx_obs)==md.mesh.numberofvertices) and (len(md.inversion.vy_obs)==md.mesh.numberofvertices):
-			print '      boundary conditions for diagnostic model: spc set as observed velocities'
-			md.diagnostic.spcvx[pos]=md.inversion.vx_obs[pos]
-			md.diagnostic.spcvy[pos]=md.inversion.vy_obs[pos]
+	if numpy.size(md.inversion.vx_obs)==md.mesh.numberofvertices and numpy.size(md.inversion.vy_obs)==md.mesh.numberofvertices:
+		print '      boundary conditions for diagnostic model: spc set as observed velocities'
+		md.diagnostic.spcvx[pos]=md.inversion.vx_obs[pos]
+		md.diagnostic.spcvy[pos]=md.inversion.vy_obs[pos]
 	else:
 		print '      boundary conditions for diagnostic model: spc set as zero'
@@ -46,46 +49,50 @@
 	#segment on Ice Front
 	#segment on Neumann (Ice Front)
-	segs1=md.mesh.segments[:,0].astype(int)-1
-	segs2=md.mesh.segments[:,1].astype(int)-1
-
-	pos=argwhere(logical_and(nodeonicefront[segs1].astype(bool),nodeonicefront[segs2].astype(bool)))
-	if (md.mesh.dimension==2):
-		pressureload=md.mesh.segments[pos,:];
+#	pos=find(nodeonicefront(md.mesh.segments(:,1)) | nodeonicefront(md.mesh.segments(:,2)));
+	pos=[i for i,(noif1,noif2) in enumerate(zip(nodeonicefront[md.mesh.segments[:,0].astype('int')-1],nodeonicefront[md.mesh.segments[:,1].astype('int')-1])) if noif1 or noif2]
+	if   md.mesh.dimension==2:
+		pressureload=md.mesh.segments[pos,:]
 	elif md.mesh.dimension==3:
-		pressureload_layer=[md.mesh.segments[pos,0:2],md.mesh.segments[pos,1]+md.mesh.numberofvertices2d,md.mesh.segments[pos,0]+md.mesh.numberofvertices2d, md.mesh.segments[pos,2]];
-		pressureload=[];
-		for i in range(1,md.mesh.numberoflayers-1):
-			pressureload=[pressureload ,pressureload_layer1[:,1:4]+(i-1)*md.mesh.numberofvertices2d, pressureload_layer1[:,5]+(i-1)*md.mesh.numberofelements2d ];
+#		pressureload_layer1=[md.mesh.segments(pos,1:2)  md.mesh.segments(pos,2)+md.mesh.numberofvertices2d  md.mesh.segments(pos,1)+md.mesh.numberofvertices2d  md.mesh.segments(pos,3)];
+		pressureload_layer1=numpy.concatenate((md.mesh.segments[pos,0:2],md.mesh.segments[pos,1]+md.mesh.numberofvertices2d,md.mesh.segments[pos,0]+md.mesh.numberofvertices2d,md.mesh.segments[pos,2]),axis=1)
+		pressureload=numpy.zeros((0,5))
+		for i in xrange(1,md.mesh.numberoflayers):
+#			pressureload=[pressureload ;pressureload_layer1(:,1:4)+(i-1)*md.mesh.numberofvertices2d pressureload_layer1(:,5)+(i-1)*md.mesh.numberofelements2d ];
+			pressureload=numpy.concatenate((pressureload,numpy.concatenate((pressureload_layer1[:,0:3]+(i-1)*md.mesh.numberofvertices2d,pressureload_layer1[:,4]+(i-1)*md.mesh.numberofelements2d),axis=1)),axis=0)
 
 	#Add water or air enum depending on the element
-	pressureload=[pressureload, 1*md.mask.elementonfloatingice(pressureload[:,end])];
+#	pressureload=[pressureload 1*md.mask.elementonfloatingice(pressureload(:,end))];
+	pressureload=numpy.concatenate((pressureload,1*md.mask.elementonfloatingice[pressureload[:,-1].astype('int')-1].reshape((-1,1))),axis=1)
 
 	#plug onto model
-	md.diagnostic.icefront=pressureload;
+	md.diagnostic.icefront=pressureload
 
 	#Create zeros basalforcings and surfaceforcings
-	if isnan(md.surfaceforcings.precipitation):
-		md.surfaceforcings.precipitation=zeros(md.mesh.numberofvertices);
+	if numpy.isnan(md.surfaceforcings.precipitation).all():
+		md.surfaceforcings.precipitation=numpy.zeros(md.mesh.numberofvertices)
 		print '      no surfaceforcings.precipitation specified: values set as zero'
-	if isnan(md.surfaceforcings.mass_balance):
-		md.surfaceforcings.mass_balance=zeros(md.mesh.numberofvertices);
+	if numpy.isnan(md.surfaceforcings.mass_balance).all():
+		md.surfaceforcings.mass_balance=numpy.zeros(md.mesh.numberofvertices)
 		print '      no surfaceforcings.mass_balance specified: values set as zero'
-	if isnan(md.basalforcings.melting_rate):
-		md.basalforcings.melting_rate=zeros(md.mesh.numberofvertices)
+	if numpy.isnan(md.basalforcings.melting_rate).all():
+		md.basalforcings.melting_rate=numpy.zeros(md.mesh.numberofvertices)
 		print '      no basalforcings.melting_rate specified: values set as zero'
-	if isnan(md.balancethickness.thickening_rate):
-		md.balancethickness.thickening_rate=zeros(md.mesh.numberofvertices);
+	if numpy.isnan(md.balancethickness.thickening_rate).all():
+		md.balancethickness.thickening_rate=numpy.zeros(md.mesh.numberofvertices)
 		print '      no balancethickness.thickening_rate specified: values set as zero'
 
-	md.prognostic.spcthickness=NaN*ones(md.mesh.numberofvertices);
-	md.balancethickness.spcthickness=NaN*ones(md.mesh.numberofvertices);
+	md.prognostic.spcthickness=float('NaN')*numpy.ones(md.mesh.numberofvertices)
+	md.balancethickness.spcthickness=float('NaN')*numpy.ones(md.mesh.numberofvertices)
 
-	if (len(md.initialization.temperature)==md.mesh.numberofvertices):
-		md.thermal.spctemperature=NaN*ones(md.mesh.numberofvertices);
-		pos=argwhere(md.mesh.vertexonsurface); md.thermal.spctemperature[pos]=md.initialization.temperature[pos]; #impose observed temperature on surface
-		if (len(md.basalforcings.geothermalflux) !=md.mesh.numberofvertices):
-			md.basalforcings.geothermalflux=zeros(md.mesh.numberofvertices);
+	if numpy.size(md.initialization.temperature)==md.mesh.numberofvertices:
+		md.thermal.spctemperature=float('NaN')*numpy.ones(md.mesh.numberofvertices)
+#		pos=find(md.mesh.vertexonsurface); md.thermal.spctemperature(pos)=md.initialization.temperature(pos); %impose observed temperature on surface
+		pos=[i for i,vos in enumerate(md.mesh.vertexonsurface) if vos]
+		md.thermal.spctemperature[pos]=md.initialization.temperature[pos]    # impose observed temperature on surface
+		if not numpy.size(md.basalforcings.geothermalflux)==md.mesh.numberofvertices:
+			md.basalforcings.geothermalflux=numpy.zeros(md.mesh.numberofvertices)
 	else:
 		print '      no thermal boundary conditions created: no observed temperature found'
 
 	return md
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/Basins/isbasin.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Basins/isbasin.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Basins/isbasin.m	(revision 12878)
@@ -9,5 +9,5 @@
 
 %First, load basin names:
-load([issmdir '/projects/ModelData/Names/Names.mat']);
+load([jplsvn '/projects/ModelData/Names/Names.mat']);
 
 
Index: issm/branches/trunk-jpl-damage/src/m/utils/Cluster/parallelrange.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Cluster/parallelrange.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Cluster/parallelrange.py	(revision 12878)
@@ -0,0 +1,25 @@
+#! /usr/bin/env python
+def parallelrange(rank,numprocs,globalsize):
+	"""
+	PARALLELRANGE - from a rank, and a number of processors, figure out a range, for parallel tasks.
+ 
+	    Usage: 
+	       i1,i2=parallelrange(rank,numprocs,globalsize)
+	"""
+
+	#We use floor. we under distribute rows. The rows left are then redistributed, therefore resulting in a more even distribution.
+	num_local_rows=[int(globalsize/numprocs) for i in xrange(numprocs)]
+
+	#There may be some rows left. Distribute evenly.
+	row_rest=globalsize - numprocs*int(globalsize/numprocs)
+
+	for i in xrange(row_rest):
+		num_local_rows[i]=num_local_rows[i]+1
+
+	i1=0
+	for i in xrange(rank-1):
+		i1+=num_local_rows[i]
+	i2=i1+num_local_rows[rank-1]-1
+
+	return i1,i2
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gamv.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gamv.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gamv.m	(revision 12878)
@@ -0,0 +1,70 @@
+function output = gamv(x,y,data,varargin);
+%GAMV - use gslib for Kriging
+%
+%   Usage:
+%      output = gamv(x,y,data,varargin)
+
+options=pairoptions(varargin{:});
+
+nlag = getfieldvalue(options,'nlag', 20);
+dlag = getfieldvalue(options,'dlag', 1000);
+
+%Write data file
+fid=fopen('cluster.dat','w');
+fprintf(fid,'%s\n','Data file');
+fprintf(fid,'%i\n',3);
+fprintf(fid,'%s\n','Xlocation');
+fprintf(fid,'%s\n','Ylocation');
+fprintf(fid,'%s\n','Data');
+fprintf(fid,'%g %g %g\n',[x y data]');
+fclose(fid);
+
+%Write parameter file
+fid=fopen('gamv.par','w');
+fprintf(fid,'\t\t\t\t%s\n','Parameters for GAMV');
+fprintf(fid,'\t\t\t\t%s\n','*******************');
+fprintf(fid,'\n');
+fprintf(fid,'%s\n','START OF PARAMETERS:');
+fprintf(fid,'%-30s %s\n','./cluster.dat'              ,'\file with data');
+fprintf(fid,'%-30s %s\n','1 2 0'                      ,'\columns for X, Y, Z coordinates');
+fprintf(fid,'%-30s %s\n','1 3  '                      ,'\number of variables, column number');
+fprintf(fid,'%-30s %s\n','-1.0e21 1.0e21'             ,'\trimming limits');
+fprintf(fid,'%-30s %s\n','gamv.out'                   ,'\file for variogram output');
+fprintf(fid,'%-30s %s\n',num2str(nlag,'%i')           ,'\number of lags');
+fprintf(fid,'%-30s %s\n',num2str(dlag,'%g')           ,'\lag separation distance');
+fprintf(fid,'%-30s %s\n',num2str(dlag/2,'%g')         ,'\lag tolerance');
+fprintf(fid,'%-30s %s\n','3'                          ,'\number of directions');
+fprintf(fid,'%-30s %s\n','0.0 90.0 50.0 0.0 90.0 50.0','\azm, atol, bandh, dip, dtol, bandv');
+fprintf(fid,'%-30s %s\n','0.0 22.5 25.0 0.0 22.5 25.0','\azm, atol, bandh, dip, dtol, bandv');
+fprintf(fid,'%-30s %s\n','90. 22.5 25.0 0.0 22.5 25.0','\azm, atol, bandh, dip, dtol, bandv');
+fprintf(fid,'%-30s %s\n','0'                          ,'\standardize sill? (0=no, 1=yes)');
+fprintf(fid,'%-30s %s\n','2'                          ,'\number of variograms');
+fprintf(fid,'%-30s %s\n','1 1 1'                      ,'\tail var., head vars., variogram type');
+fprintf(fid,'%-30s %s\n','1 1 3'                      ,'\tail var., head vars., variogram type');
+fclose(fid);
+
+%Call gamv
+system([issmdir() '/externalpackages/gslib/install/gamv gamv.par']);
+delete('gamv.par');
+
+%Read output
+output   = struct('Semivariogram',[],'Covariance',[]);
+counter1 = 1;
+counter2 = 1;
+fid=fopen('gamv.out','r');
+while (~feof(fid)),
+	A=fscanf(fid,'%s',1);
+	if strcmp(A,'Covariance');
+		A=fscanf(fid,'%s',4); %Read tail:Data head:Data direction  2
+		output(counter1).Covariance=fscanf(fid,'%i %g %g %i %g %g',[6 nlag+2])';
+		counter1=counter1+1;
+	elseif strcmp(A,'Semivariogram'),
+		A=fscanf(fid,'%s',4); %Read tail:Data head:Data direction  2
+		output(counter2).Semivariogram=fscanf(fid,'%i %g %g %i %g %g',[6 nlag+2])';
+		counter2=counter2+1;
+	else
+		%do nothing
+	end
+end
+fclose(fid);
+delete('gamv.out')
Index: issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gslib.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gslib.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/gslib.m	(revision 12878)
@@ -0,0 +1,112 @@
+function output = gslib(x,y,data,varargin);
+%GSLIB - use gslib for Kriging
+%
+%   Usage:
+%      output = gslib(x,y,data,varargin)
+
+%Output Matrix
+xmin   = xl(1);
+ymin   = yl(1);
+nx     = 101;
+ny     = 101;
+deltax = 5000;
+deltay = 5000;
+
+%Variogram
+nugget=10;
+sill  =164;
+range =25763;
+
+%Kriging options
+mindata = 1;
+maxdata = 50;
+maxsearchradius = 50000;
+
+%Some intermediaries (Convert to gslib's parameters);
+c = (sill-nugget);
+a = sqrt(3)*range;
+
+%Write data file
+fid=fopen('cluster.dat','w');
+fprintf(fid,'%s\n','Data file');
+fprintf(fid,'%i\n',3);
+fprintf(fid,'%s\n','Xlocation');
+fprintf(fid,'%s\n','Ylocation');
+fprintf(fid,'%s\n','Data');
+fprintf(fid,'%g %g %g\n',[x y data]');
+fclose(fid);
+
+if 0, %GAMV
+	%Write parameter file
+	fid=fopen('gamv.par','w');
+	fprintf(fid,'\t\t\t\t%s\n','Parameters for GAMV');
+	fprintf(fid,'\t\t\t\t%s\n','*******************');
+	fprintf(fid,'\n');
+	fprintf(fid,'%s\n','START OF PARAMETERS:');
+	fprintf(fid,'%-30s %s\n','./cluster.dat'              ,'\file with data');
+	fprintf(fid,'%-30s %s\n','1 2 0'                      ,'\columns for X, Y, Z coordinates');
+	fprintf(fid,'%-30s %s\n','1 3  '                      ,'\number of variables, column number');
+	fprintf(fid,'%-30s %s\n','-1.0e21 1.0e21'             ,'\trimming limits');
+	fprintf(fid,'%-30s %s\n','gamv.out'                   ,'\file for variogram output');
+	fprintf(fid,'%-30s %s\n','20'                         ,'\number of lags');
+	fprintf(fid,'%-30s %s\n','5.0'                        ,'\lag separation distance');
+	fprintf(fid,'%-30s %s\n','3.0'                        ,'\lag tolerance');
+	fprintf(fid,'%-30s %s\n','3'                          ,'\number of directions');
+	fprintf(fid,'%-30s %s\n','0.0 90.0 50.0 0.0 90.0 50.0','\azm, atol, bandh, dip, dtol, bandv');
+	fprintf(fid,'%-30s %s\n','0.0 22.5 25.0 0.0 22.5 25.0','\azm, atol, bandh, dip, dtol, bandv');
+	fprintf(fid,'%-30s %s\n','90. 22.5 25.0 0.0 22.5 25.0','\azm, atol, bandh, dip, dtol, bandv');
+	fprintf(fid,'%-30s %s\n','0'                          ,'\standardize sill? (0=no, 1=yes)');
+	fprintf(fid,'%-30s %s\n','2'                          ,'\number of variograms');
+	fprintf(fid,'%-30s %s\n','1 1 1'                      ,'\tail var., head vars., variogram type');
+	fprintf(fid,'%-30s %s\n','1 1 3'                      ,'\tail var., head vars., variogram type');
+	fclose(fid);
+
+	%Call gamv
+	system([issmdir() '/externalpackages/gslib/install/gamv gamv.par']);
+
+else, %Kriging KB2D
+	%Write parameter file
+	fid=fopen('kb2d.par','w');
+	fprintf(fid,'\t\t\t\t%s\n','Parameters for KB2D');
+	fprintf(fid,'\t\t\t\t%s\n','*******************');
+	fprintf(fid,'\n');
+	fprintf(fid,'%s\n','START OF PARAMETERS:');
+	fprintf(fid,'%-30s %s\n','./cluster.dat'                  ,'\file with data');
+	fprintf(fid,'%-30s %s\n','1 2 3'                          ,'\columns for X, Y and variable');
+	fprintf(fid,'%-30s %s\n','-1.0e21 1.0e21'                 ,'\trimming limits');
+	fprintf(fid,'%-30s %s\n','0'                              ,'\debugging level: 0,1,2,3');
+	fprintf(fid,'%-30s %s\n','kb2d.dbg'                       ,'\file for debuggging output');
+	fprintf(fid,'%-30s %s\n','kb2d.out'                       ,'\file for kriged output');
+	fprintf(fid,'%-30s %s\n',num2str([nx xmin deltax],'%i %10g %6g')  ,'\nx, xmn, xsiz');
+	fprintf(fid,'%-30s %s\n',num2str([ny ymin deltay],'%i %10g %6g')  ,'\nx, xmn, xsiz');
+	fprintf(fid,'%-30s %s\n','1 1'                            ,'\x and y block discretization');
+	fprintf(fid,'%-30s %s\n',num2str([mindata maxdata],'%6g') ,'\min and max data for kriging');
+	fprintf(fid,'%-30s %s\n',num2str(maxsearchradius,'%6g')   ,'\max search radius');
+	fprintf(fid,'%-30s %s\n','1 2.302'                        ,'\0=SK, 1=OK, (mean if SK)');
+	fprintf(fid,'%-30s %s\n',['1 ' num2str(nugget)]           ,'\nst, nugget effect');
+	fprintf(fid,'%-30s %s\n',['3 ' num2str([c 0.0 a a],'%10g')],'\it, c, azm, a_max, a_min');
+	fclose(fid);
+
+	tic;system([issmdir() '/externalpackages/gslib/install/kb2d kb2d.par']);toc;
+	delete('kb2d.par');
+
+	%Read output
+	fid=fopen('kb2d.out','r');
+	while (~feof(fid)),
+		A=fscanf(fid,'%s',1);
+		if strcmp(A,'KB2D');
+			A=fscanf(fid,'%s',1); %Read output
+			params=fscanf(fid,'%i %i %i %i %g %g %g %g %g %g %1',[11 1]);
+		elseif strcmp(A,' Estimate'),
+			continue;
+		elseif strcmp(A,'Estimation'),
+			A=fscanf(fid,'%s',1); %Read Variance
+			A=fscanf(fid,'%g %g',[params(1) params(2)*params(3)]);
+			B=A(1,:); B=reshape(B,[params(3),params(2)])';
+			E=A(2,:); E=reshape(E,[params(3),params(2)])';
+		else
+			%do nothing
+		end
+	end
+	fclose(fid);
+end
Index: issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/pkriging.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/pkriging.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/pkriging.m	(revision 12878)
@@ -0,0 +1,55 @@
+function [B E]=pkriging(x,y,observations,x_interp,y_interp,varargin);
+%PKRIGING - parallel Kriging
+%
+%   Usage:
+%      [B E]=pkriging(x,y,observations,x_interp,y_interp,varargin);
+
+options=pairoptions(varargin{:});
+cluster=getfieldvalue(options,'cluster',generic('np',10));
+options=removefield(options,'cluster',0);
+name   = ['krig' num2str(feature('GetPid'))];
+
+% =========================================   MARSHALL.m =================================================
+disp(['marshalling file ' name '.bin']);
+fid=fopen([name '.bin'],'wb');
+if fid==-1,
+	error(['marshall error message: could not open ' name '.bin file for binary writing']);
+end
+
+%First, write MaximumNumberOfEnum to make sure that the Enums are synchronized
+WriteData(fid,'enum',MaximumNumberOfEnums(),'data',true,'format','Boolean');
+
+%Write all data
+WriteData(fid,'enum',0,'data',x,'format','DoubleMat');
+WriteData(fid,'enum',1,'data',y,'format','DoubleMat');
+WriteData(fid,'enum',2,'data',observations,'format','DoubleMat');
+WriteData(fid,'enum',3,'data',x_interp,'format','DoubleMat');
+WriteData(fid,'enum',4,'data',y_interp,'format','DoubleMat');
+options.marshall(fid,5);
+st=fclose(fid);
+if st==-1,
+	error(['marshall error message: could not close file ' name '.bin']);
+end
+% =========================================   MARSHALL.m =================================================
+
+%Launch job on remote cluster
+BuildKrigingQueueScript(cluster,name,'',1,0,0); %gather, valgrind, gprof
+tic
+LaunchQueueJob(cluster,name,name,{[name '.bin'] [name '.queue']});
+toc
+choice=input('Is the job successfully completed? (y/n)','s');
+Download(cluster,name,{[name '.outbin']});
+structure=parseresultsfromdisk([name '.outbin'],0);
+delete([name '.outlog']);
+delete([name '.errlog']);
+delete([name '.outbin']);
+delete([name '.bin']);
+if ~ispc,
+	delete([name '.tar.gz']);
+end
+
+%Process results
+B=structure.AutodiffForward;
+B=reshape(B,size(x_interp,2),size(x_interp,1))';
+E=structure.AutodiffIsautodiff;
+E=reshape(E,size(x_interp,2),size(x_interp,1))';
Index: issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/varmap.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/varmap.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/varmap.m	(revision 12878)
@@ -0,0 +1,55 @@
+function output = varmap(x,y,data,varargin);
+%VARMAP - use gslib for Kriging
+%
+%   Usage:
+%      output = varmap(x,y,data,varargin)
+
+options=pairoptions(varargin{:});
+
+nxlag = getfieldvalue(options,'nxlag', 20);
+nylag = getfieldvalue(options,'nylag', 20);
+dxlag = getfieldvalue(options,'dxlag', 1000);
+dylag = getfieldvalue(options,'dylag', 1000);
+
+%Write data file
+fid=fopen('cluster.dat','w');
+fprintf(fid,'%s\n','Data file');
+fprintf(fid,'%i\n',3);
+fprintf(fid,'%s\n','Xlocation');
+fprintf(fid,'%s\n','Ylocation');
+fprintf(fid,'%s\n','Data');
+fprintf(fid,'%g %g %g\n',[x y data]');
+fclose(fid);
+
+%Write parameter file
+fid=fopen('varmap.par','w');
+fprintf(fid,'\t\t\t\t%s\n','Parameters for GAMV');
+fprintf(fid,'\t\t\t\t%s\n','*******************');
+fprintf(fid,'\n');
+fprintf(fid,'%s\n','START OF PARAMETERS:');
+fprintf(fid,'%-30s %s\n','./cluster.dat'              ,'\file with data');
+fprintf(fid,'%-30s %s\n','1 3  '                      ,'\number of variables, column number');
+fprintf(fid,'%-30s %s\n','-1.0e21 1.0e21'             ,'\trimming limits');
+fprintf(fid,'%-30s %s\n','0    '                      ,'\1=regular grid, 0=scattered values');
+fprintf(fid,'%-30s %s\n','50 50 1'                    ,'\if =1: nx, ny, nz');
+fprintf(fid,'%-30s %s\n','1.0 1.0 1.0'                ,'\       xsiz, ysiz, zsiz if igrid=1');
+fprintf(fid,'%-30s %s\n','1 2 0'                      ,'\if =0: columns for x, y and z coordinates');
+fprintf(fid,'%-30s %s\n','varmap.out'                 ,'\file for variogram output');
+fprintf(fid,'%-30s %s\n',num2str([nxlag nylag 0],'%i '),'\nxlag, nylag, nzlag');
+fprintf(fid,'%-30s %s\n',num2str([dxlag dylag 1],'%g %g %i'),'\dxlag, dylag, dzlag');
+fprintf(fid,'%-30s %s\n','5'                          ,'\minimum number of pairs');
+fprintf(fid,'%-30s %s\n','0'                          ,'\standardize sill? (0=no, 1=yes)');
+fprintf(fid,'%-30s %s\n','1'                          ,'\number of variograms');
+fprintf(fid,'%-30s %s\n','1 1 1'                      ,'\tail, head, variogram type');
+fclose(fid);
+
+%Call varmap
+system([issmdir() '/externalpackages/gslib/install/varmap varmap.par']);
+delete('varmap.par');
+
+%Read output
+fid=fopen('varmap.out','r');
+A = textscan(fid,'%f %f %f %f %f %f','headerlines',8);
+fclose(fid);
+delete('varmap.out')
+output = reshape(A{1},[2*nxlag+1 2*nylag+1]);
Index: issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcoarsen.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcoarsen.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcoarsen.m	(revision 12878)
@@ -26,5 +26,5 @@
 %Get exp oldfile
 [path root ext ver]=fileparts(oldfile);
-A=expread(oldfile,1);
+A=expread(oldfile);
 numprofiles=size(A,2);
 
Index: issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcontract.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcontract.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Exp/expcontract.m	(revision 12878)
@@ -8,5 +8,5 @@
 
 
-contour=expread(oldfile,1);
+contour=expread(oldfile);
 num=numel(contour.x);
 
Index: issm/branches/trunk-jpl-damage/src/m/utils/Exp/manipulation/cutarea.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Exp/manipulation/cutarea.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Exp/manipulation/cutarea.m	(revision 12878)
@@ -87,8 +87,10 @@
 									A(selection).x=x(1:p1);
 									A(selection).y=y(1:p1);
+									closed(selection)=0;
 									A(end+1).x=x(p2:end);
 									A(end).y=y(p2:end);
 									A(end).density=A(selection).density;
 									A(end).name=A(selection).name;
+									closed(end+1)=0;
 									numprofiles=numprofiles+1;
 									numpoints=numpoints-(p2-p1-1);
@@ -113,4 +115,5 @@
 								else
 									%cut in 2 profiles
+									closed(selection)=0;
 									A(selection).x=x(1:p2);
 									A(selection).y=y(1:p2);
@@ -119,4 +122,5 @@
 									A(end).density=A(selection).density;
 									A(end).name=A(selection).name;
+									closed(end+1)=0;
 									numprofiles=numprofiles+1;
 									numpoints=numpoints-(p1-p2-1);
Index: issm/branches/trunk-jpl-damage/src/m/utils/Geometry/find_point.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Geometry/find_point.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Geometry/find_point.m	(revision 12878)
@@ -8,4 +8,7 @@
 %      f=find_point(tabx,taby,pointx,pointy)
 
+%Compute distance between point and cloud of points
 distance=sqrt((tabx-pointx).^2+(taby-pointy).^2);
-f=find(distance==min(min(distance)));
+
+%find index of the minimum distance and return the first one only
+f=find(distance==min(min(distance)),1);
Index: issm/branches/trunk-jpl-damage/src/m/utils/Kml/exp2kml.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Kml/exp2kml.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Kml/exp2kml.m	(revision 12878)
@@ -8,5 +8,5 @@
 
 %First, read exp file
-domain=expread(input,1);
+domain=expread(input);
 
 
Index: issm/branches/trunk-jpl-damage/src/m/utils/Miscellaneous/issmdoc.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Miscellaneous/issmdoc.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Miscellaneous/issmdoc.m	(revision 12878)
@@ -9,7 +9,7 @@
 disp(sprintf('%s','	   md=model;                                %creates a new empty model structure'));
 disp(sprintf('%s','	   md=triangle(md,''DomainOutline.exp'',50000);   %creates a mesh of the domain outline with a resolution of 50000m'));
-disp(sprintf('%s','	   md=geography(md,''all'','''');               %defines the glacier system as an ice shelf (no island)'));
+disp(sprintf('%s','	   md=setmask(md,''all'','''');               %defines the glacier system as an ice shelf (no island)'));
 disp(sprintf('%s','	   md=parameterize(md,''Square.par'');        %fills all the other fields of the model'));
-disp(sprintf('%s','	   md=setelementstype(md,''macayeal'',''all''); %defines all elements as MacAyeal''s'));
+disp(sprintf('%s','	   md=setflowequation(md,''macayeal'',''all''); %defines all elements as MacAyeal''s'));
 disp(sprintf('%s','	   md=solve(md,DiagnosticSolutionEnum);   %generate the velocity field'));
 disp(sprintf('%s','	   plotmodel(md,''data'',md.results.DiagnosticSolution.Vel);    %displays the velocity (type plotdoc for plotmodel help)'));
Index: issm/branches/trunk-jpl-damage/src/m/utils/Model/loadmodel.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Model/loadmodel.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Model/loadmodel.m	(revision 12878)
@@ -12,6 +12,12 @@
 	error('loadmodel usage error: md=loadmodel(path)');
 end
+
 %check existence
-if ~exist(path)
+if exist(path,'file')
+	%do nothing
+elseif exist([path '.mat'],'file')
+	%add extension
+	path = [path '.mat'];
+else
 	error(['loadmodel error message: file ' path ' does not exist']);
 end
Index: issm/branches/trunk-jpl-damage/src/m/utils/Numerics/cfl_step.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Numerics/cfl_step.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Numerics/cfl_step.m	(revision 12878)
@@ -8,5 +8,5 @@
 %
 %   Example:
-%      dt=cfl_step(md,md,md.results.DiagnosticSolution.Vx,md.results.DiagnosticSolution.Vy)
+%      dt=cfl_step(md,md.results.DiagnosticSolution.Vx,md.results.DiagnosticSolution.Vy)
 
 %Check length of velocities 
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/ismumps.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/ismumps.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/ismumps.py	(revision 12878)
@@ -0,0 +1,37 @@
+import os
+from issmdir import *
+from MatlabFuncs import *
+
+def ismumps():
+	"""
+	ISMUMPS - figure out if MUMPS package was compiled with ISSM
+ 
+	    Usage:
+	        flag=ismumps();
+	"""
+
+	configfile=os.path.join(issmdir(),'bin','config.h')    #should find it in the install target
+	if not os.path.exists(configfile):
+		raise RuntimeError("File '%s' not found. ISSM has not been configured yet!" % configfile)
+
+	#go through the file, and recover the line we want
+	flag=2
+	try:
+		fid=open(configfile,'r')
+	except IOError as e:
+		raise IOError("could not open file: '%s'" % configfile)
+
+	for tline in fid:
+		if strncmp(tline,'/* #undef _HAVE_MUMPS_ */',25):
+			flag=0
+			break
+		if  strncmp(tline,'#define _HAVE_MUMPS_',20):
+			flag=1
+			break
+
+	fid.close()
+	if flag==2:
+		raise RuntimeError("could not determine whether MUMPS was or was not compiled.")
+
+	return flag
+
